# -*- encoding: utf-8 -*-
# -----------------------------------------------------------------------------
# @File Name  : draw.py
# @Time       : 2020/11/19 上午10:51
# @Author     : X. Peng
# @Email      : acepengxiong@163.com
# @Software   : PyCharm
# -----------------------------------------------------------------------------

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.ticker import FuncFormatter
from matplotlib.font_manager import FontProperties


def to_percent(temp, position):
    return '%1.0f' % temp + '%'

def draw_stacked_column_chart():
    """堆叠柱状图"""

    plt.title('Scores by group and gender')

    # ind = np.arange(12)  # [ 0  1  2  3  4  5  6  7  8  9 10 11 12]
    # plt.xticks(ind, ('M1', 'M2', 'M3', 'M4', 'M5', 'M6', 'M7', 'M8', 'M9', 'M10', 'M11', 'M12'))
    #
    # plt.yticks(np.arange(0, 81, 20))
    #
    # Bottom = (52, 49, 48, 47, 44, 43, 41, 41, 40, 38, 36, 31, 29)
    # Center = (38, 40, 45, 42, 48, 51, 53, 54, 57, 59, 57, 64, 62)
    # Top = (10, 11, 7, 11, 8, 6, 6, 5, 3, 3, 7, 5, 9)
    #
    # d = []
    # for i in range(0, len(Bottom)):
    #     sum = Bottom[i] + Center[i]
    #     d.append(sum)
    #
    # width = 0.8  # 设置条形图一个长条的宽度
    # p1 = plt.bar(ind, Bottom, width, color='blue')
    # p2 = plt.bar(ind, Center, width, bottom=Bottom, color='green')
    # p3 = plt.bar(ind, Top, width, bottom=d, color='red')
    #
    # plt.legend((p1[0], p2[0], p3[0]), ('Bottom', 'Center', 'Top'), loc=3)
    #
    # plt.show()
    N = 5
    product1 = np.array([10, 20, 30, 40, 50])
    product2 = np.array([20, 20, 20, 20, 20])
    product3 = np.array([20, 20, 20, 20, 20])
    line = np.array([10, 15, 5, 20, 36])
    ind = np.arange(N)  # the x locations for the groups
    width = 0.35  # the width of the bars: can also be len(x) sequence

    p1 = plt.bar(ind, product1, width, color='#222A77', alpha=0.8)
    p2 = plt.bar(ind, product2, width, bottom=product1, color='#6C71AA', alpha=0.8)
    p3 = plt.bar(ind, product3, width, bottom=product2+product1, color='#E1BC95', alpha=0.8)

    # plt.ylabel('Scores')
    plt.title('Scores by group and gender')
    plt.xticks(ind, ('G1', 'G2', 'G3', 'G4', 'G5'))
    # plt.yticks(np.arange(0, 81, 10))

    ax1 = plt.legend((p1[0], p2[0], p3[0]), ('product1', 'product2', 'product3'))

    # 画折线图
    ax2 = ax1.twinx()
    line = ax2.plot(ind, line, color='#C6A774', marker='', ms=1000, label=u"总体收益")

    plt.gca().yaxis.set_major_formatter(FuncFormatter(to_percent))
    plt.show()

if __name__ == '__main__':
    draw_stacked_column_chart()
